# -*- coding:Utf-8 -*-

import es
import geeky
import gamethread
import playerlib
import popuplib
import random
import psyco
import usermsg

psyco.full()

#------------------------------------------------------#
#-------------------- Présentation --------------------#
#------------------------------------------------------#
info = es.AddonInfo()
info.name = 'Combat des rois'
info.version = '2.0'
info.author = 'Geeky'
info.url = 'http://addons.eventscripts.com/'
info.basename = 'cdr'
info.description = 'Chaque armée, menée par son Roi doit remporter la victoire.'
es.ServerVar('combat_des_rois_ver', info.version, 'Combat des rois: By Geeky').makepublic()

players = {}
rois = []
suicide_actif = 0

#------------------------------------------------------#
#-------------------- Soldat du Roi -------------------#
#------------------------------------------------------#
class Soldat():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenSoldat')
	
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 100)
		geeky.giveWeapon(self.userid, 'knife')
		if self.equipe == 3:
			geeky.giveWeapon(self.userid, 'usp')
			geeky.giveWeapon(self.userid, 'famas')
		else:
			geeky.giveWeapon(self.userid, 'glock')
			geeky.giveWeapon(self.userid, 'galil')
		
	def attaque(self, ev = 0):
		geeky.setShot(self.userid, 0)
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#------------------- Garde du corps -------------------#
#------------------------------------------------------#
class GardeCorps():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenGarde du corps')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 100)
		geeky.setSpeed(self.userid, 1.2)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'm3')
		if self.equipe == 3:
			geeky.giveWeapon(self.userid, 'usp')
		else:
			geeky.giveWeapon(self.userid, 'glock')
		
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		for player in geeky.nearPlayersTeam(self.userid, self.equipe, 900):
			if players[str(player)].isRoi or (geeky.alivePlayers(self.equipe) == 1):
				return
		vieActuelle = geeky.getHealth(self.userid)
		if vieActuelle > 5:
			geeky.setHealth(self.userid, vieActuelle - 1)
			geeky.tell(self.userid, '[CdR MoD]', 'Si vous vous éloignez trop du Roi, vous perdez des vies!')
		else:
			geeky.setHealth(self.userid, 1)
					
#------------------------------------------------------#
#--------------------- Djihadiste ---------------------#
#------------------------------------------------------#
class Djihadiste():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 1
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenDjihadiste')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 50)
		geeky.setHealth(self.userid, 75)
		geeky.setSpeed(self.userid, 1.1)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'hegrenade')
		if self.equipe == 3:
			geeky.giveWeapon(self.userid, 'p228')
		else:
			geeky.giveWeapon(self.userid, 'elite')
		
	def player_death(self, ev = 0):
		if random.randint(1, 100) <= 70:
			geeky.explode(self.userid, 1000)			
			nom = es.getplayername(self.userid)
			geeky.msg('[CdR MoD]', '%s a réussi son attaque suicide.' % nom)
			
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0

#------------------------------------------------------#
#---------------------- Commando ----------------------#
#------------------------------------------------------#
class Commando():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenCommando')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 100)
		geeky.setHealth(self.userid, 100)
		geeky.setSpeed(self.userid, 0.9)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'deagle')
		geeky.giveWeapon(self.userid, 'p90')
		geeky.giveWeapon(self.userid, 'hegrenade')
		geeky.giveWeapon(self.userid, 'flashbang')
		geeky.giveWeapon(self.userid, 'flashbang')
		geeky.giveWeapon(self.userid, 'smokegrenade')
		
	def player_jump(self, ev = 0):
		vec1 = es.getplayerprop(self._serid,'CBasePlayer.localdata.m_vecVelocity[0]')
		vec2 = es.getplayerprop(self.userid,'CBasePlayer.localdata.m_vecVelocity[1]')
		vec1 = float(vec1)*(0.06)
		vec2 = float(vec2)*(0.06)
		es.setplayerprop(self.userid,'CBasePlayer.localdata.m_vecBaseVelocity', es.createvectorstring(vec1,vec2,0))
		
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#--------------------- Tête brulée --------------------#
#------------------------------------------------------#
class TeteBrulee():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenTête brulée')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 100)
		geeky.setHealth(self.userid, 150)
		geeky.setSpeed(self.userid, 0.8)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'm249')
		if self.equipe == 3:
			geeky.giveWeapon(self.userid, 'usp')
		else:
			geeky.giveWeapon(self.userid, 'glock')
		
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#---------------------- Sniper ------------------------#
#------------------------------------------------------#
class Sniper():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenTireur d\'élite')
							
	def player_spawn(self, ev = 0):
		geeky.setHealth(self.userid, 80)
		geeky.setSpeed(self.userid, 1.2)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'scout')
		geeky.giveWeapon(self.userid, 'deagle')
		geeky.giveWeapon(self.userid, 'smokegrenade')
		
	def attaque(self, ev = 0):
		if ev['weapon'] == 'scout':
			chance = random.randint(1, 100)
			if chance <= 60:
				geeky.freeze(ev['userid'])
				gamethread.delayed(0.5, geeky.unfreeze, ev['userid'])
				nom = es.getplayername(self.userid)
				geeky.tell(ev['userid'], '[CdR MoD]', 'Vous avez été freeze par #lightgreen%s.' % nom)
				nom = es.getplayername(ev['userid'])
				geeky.tell(self.userid, '[CdR MoD]', 'Vous avez freeze #lightgreen%s.' % nom)
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#----------------------- Espion -----------------------#
#------------------------------------------------------#
class Espion():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenEspion')
							
	def player_spawn(self, ev = 0):
		geeky.setHealth(self.userid, 50)
		geeky.setSpeed(self.userid, 1.3)
		geeky.setAlpha(self.userid, 35)
		geeky.giveWeapon(self.userid, 'knife')
			
	def attaque(self, ev = 0):
		if ev['weapon'] == 'knife':
			geeky.setModel(self.userid, geeky.getModel(ev['userid']))
			geeky.setAlpha(self.userid, 255)
			geeky.tell(self.userid, '[CdR MoD]', 'Vous avez pris l\'apparence d\'un ennemi.')
	
	def player_hurt(self, ev = 0):
		model = ev['attacker']
		while int(es.getplayerteam(model)) != self.equipe:
			model = random.choice(es.getUseridList())
		geeky.setModel(self.userid, geeky.getModel(model))
		geeky.setAlpha(self.userid, 35)
		geeky.tell(self.userid, '[CdR MoD]', 'Vous n\'êtes plus camouflé.')
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#----------------------- Geeky ------------------------#
#------------------------------------------------------#
class Geeky():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenGeeky')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 45)
		geeky.setHealth(self.userid, 100)
		geeky.giveWeapon(self.userid, 'knife')
		if self.equipe == 3:
			geeky.giveWeapon(self.userid, 'usp')
			geeky.giveWeapon(self.userid, 'm4a1')
		else:
			geeky.giveWeapon(self.userid, 'glock')
			geeky.giveWeapon(self.userid, 'ak47')
		
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0
		
#------------------------------------------------------#
#---------------------- Medecin -----------------------#
#------------------------------------------------------#
class Medecin():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = False
		self.respawn = 2
		geeky.tell(userid, '[CdR MoD]', 'Votre Classe: #lightgreenMédecin')
							
	def player_spawn(self, ev = 0):
		geeky.setArmor(self.userid, 20)
		geeky.setHealth(self.userid, 115)
		geeky.setSpeed(self.userid, 1.05)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'p228')
		geeky.giveWeapon(self.userid, 'tmp')
		
	def attaque(self, ev = 0):
		return 0
		
	def player_hurt(self, ev = 0):
		return 0
		
	def player_death(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		for player in geeky.nearPlayersTeam(self.userid, self.equipe, 100):
			geeky.setHealth(self.userid, geeky.getHealth(player) + 1)
		
#------------------------------------------------------#
#------------------------ Roi -------------------------#
#------------------------------------------------------#
class Roi():
	def __init__(self, userid = 0):
		self.userid = userid
		self.equipe = int(es.getplayerteam(userid))
		self.isRoi = True
		self.respawn = 1
		geeky.tell(userid, '[CdR MoD]', 'Vous êtes le roi, remportez la victoire ou mourrez!')
							
	def player_spawn(self, ev = 0):
		geeky.setHealth(self.userid, 500)
		geeky.setSpeed(self.userid, 1.2)
		geeky.giveWeapon(self.userid, 'knife')
		geeky.giveWeapon(self.userid, 'hegrenade')
		geeky.giveWeapon(self.userid, 'flashbang')
		geeky.giveWeapon(self.userid, 'flashbang')
		geeky.giveWeapon(self.userid, 'smokegrenade')
		geeky.giveWeapon(self.userid, 'deagle')
		if self.equipe == 3:
			geeky.setColor(self.userid, 1,1,255)
		else:
			geeky.setColor(self.userid, 255,1,1)
		
	def player_hurt(self, ev = 0):
		for player in geeky.playerListAlive(self.equipe):
			geeky.tell(player, '[CdR MoD]', 'Votre roi est attaqué,#lightgreen Protégez-le#default!')
			
	def player_death(self, ev = 0):
		geeky.addFrag(ev['attacker'], 4)
		geeky.msg('[CdR MoD]', 'Un roi est mort!')
		forcerPerdant(self.equipe)
		
	def attaque(self, ev = 0):
		return 0
		
	def player_jump(self, ev = 0):
		return 0
		
	def player_footstep(self, ev = 0):
		return 0

#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
#----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		
#------------------------------------------------------#
#------------ Chargement / Désinstallation ------------#
#------------------------------------------------------#
def load():
	es.server.queuecmd('mp_restartgame 1')
	es.addons.registerClientCommandFilter(clientCommandFilter)
	es.doblock('corelib/noisy_on')
	es.server.queuecmd('es_load cdr/menu')
	es.flags('add', 'cheat', 'kill')
	es.regsaycmd('!suicide', 'cdr/suicide')

def unload():
	gamethread.cancelDelayed('tempos')
	gamethread.cancelDelayed('cyclesAssault')
	global players
	players = {}
	es.addons.unregisterClientCommandFilter(clientCommandFilter)
	es.doblock('corelib/noisy_off')
	es.server.queuecmd('es_unload cdr/menu')
	es.unregsaycmd('!suicide')
	
#------------------------------------------------------#
#---------------- Début / Fin de round ----------------#
#------------------------------------------------------#
def round_start(ev):
	global players
	global suicide_actif
	global rois
	suicide_actif = 0
	es.server.queuecmd('sv_alltalk 0')
	geeky.msg('[CdR MoD]', 'Ce mod. a été créé par #lightgreen[Geeky™]#default.')
	geeky.msg('[CdR MoD]', 'http://steamcommunity.com/groups/cdrmod')
	
	geeky.removeBuyZones()
	geeky.removeBombZones()
	geeky.removeHostageZones()
	geeky.noBlock()
	if (geeky.alivePlayers(3) >= 1) and (geeky.alivePlayers(2) >= 1):
		if rois == []:
			rois.append(0)
			rois.append(0)
		roiCT = str(geeky.randomAlivePlayer(3))
		while (roiCT == rois[0]) and (geeky.alivePlayers(3) != 1):
			roiCT = str(geeky.randomAlivePlayer(3))
		players[roiCT] = Roi(roiCT)
		players[roiCT].player_spawn(ev)
		roiT = str(geeky.randomAlivePlayer(2))
		while (roiT == rois[1]) and (geeky.alivePlayers(2) != 1):
			roiT = str(geeky.randomAlivePlayer(2))
		players[roiT] = Roi(roiT)
		players[roiT].player_spawn(ev)
		rois = []
		rois.append(roiCT)
		rois.append(roiT)
		for joueur in geeky.playerListAlive(3):
			nom_roi = str(es.getplayername(roiCT))
			geeky.tellLine(joueur)
			geeky.tell(joueur, '[CdR MoD]', 'Votre souverain est #lightgreen%s #default!' % nom_roi)
			es.centertell(joueur, 'Votre Roi est %s !' % nom_roi)
		for joueur in geeky.playerListAlive(2):
			nom_roi = str(es.getplayername(roiT))
			geeky.tellLine(joueur)
			geeky.tell(joueur, '[CdR MoD]', 'Votre souverain est #lightgreen%s #default!' % nom_roi)
			es.centertell(joueur, 'Votre Roi est %s !' % nom_roi)
	geeky.msg('[CdR MoD]', 'Veuillez choisir une classe dans le menu de gauche.')
	geeky.msg('[CdR MoD]', 'Choix automatique dans #lightgreen15 secondes#default.')
	gamethread.delayedname(5, 'cyclesAssault', nouvelAssault, 30)
	gamethread.delayedname(20, 'tempos', activerSuicide)
	
def round_end(ev):
	gamethread.cancelDelayed('tempos')
	gamethread.cancelDelayed('cyclesAssault')
	global players
	players = {}
	geeky.removeAllWeapons()
	
#------------------------------------------------------#
#--------------------- Evenements ---------------------#
#------------------------------------------------------#	
def player_spawn(ev):
	if ev['es_userteam'] not in ('2', '3'): return
	if es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'): return
	global players
	geeky.setColor(ev['userid'], 255,255,255)
	geeky.removePlayerWeapons(ev['userid'])
	if ev['userid'] in players:
		if players[ev['userid']] is not None:
			players[ev['userid']].player_spawn(ev)
	else:
		players[ev['userid']] = None
	geeky.tell(ev['userid'], '[CdR MoD]', 'Tapez #lightgreen!aide #default dans le chat pour obtenir l\'aide')
	gamethread.delayedname(3, 'tempos', menuClasses, ev['userid'])
	gamethread.delayedname(18, 'tempos', choixAutomatiqueClasse, ev['userid'])
		
def player_hurt(ev):
	if ev['userid'] in players:
		if players[ev['userid']] != None:
			players[ev['userid']].player_hurt(ev)
	if ev['attacker'] in players:
		if players[ev['attacker']] != None:
			players[ev['attacker']].attaque(ev)
	if (geeky.getHealth(ev['userid']) - int(ev['dmg_health'])) < 1:
		geeky.removePlayerWeapons(ev['userid'])
		
def player_death(ev):
	geeky.removePlayerWeapons(ev['userid'])
	geeky.removeWeaponsOnGround()
	geeky.disolveRagdoll(ev['userid'])
	global players
	if ev['userid'] in players:
		players[ev['userid']].player_death(ev)
	
def player_jump(ev):
	if ev['userid'] in players:
		if players[ev['userid']] != None:
			players[ev['userid']].player_jump(ev)
			
def player_disconnect(ev):
	if ev['userid'] in players:
		if players[ev['userid']] != None:
			players[ev['userid']].player_death(ev)
			
def player_footstep(ev):
	if ev['userid'] in players:
		if players[ev['userid']] != None:
			players[ev['userid']].player_footstep(ev)
			
def player_disconnect(ev):
	if players[ev['userid']].isRoi:
		forcerPerdant(players[ev['userid']].equipe)
			
#------------------------------------------------------#
#----------------- Choix de la classe -----------------#
#------------------------------------------------------#	
def menuClasses(userid):
	global players
	if userid in players:
		if players[str(userid)] == None:
			steamid = es.getplayersteamid(userid)
			if steamid == 'BOT':
				players[str(userid)] = Soldat(userid)
				players[str(userid)].player_spawn()
				return
			menu = popuplib.easymenu('classe_%s' % userid, None, choisirClasse)
			menu.settitle('Sélectionnez une classe:')
			menu.addoption('Soldat', 'Soldat')
			menu.addoption('Garde du corps', 'Garde du corps')
			menu.addoption('Djihadiste', 'Djihadiste')
			menu.addoption('Commando', 'Commando')
			menu.addoption('Tête brulée', 'Tête brulée')
			menu.addoption('Tireur d\'élite', "Tireur d'élite")
			menu.addoption('Espion', 'Espion')
			menu.addoption('Geeky', 'Geeky')
			menu.addoption('Médecin', 'Médecin')
			menu.send(userid)
	
def choisirClasse(userid, choice, popupid):
	global players
	if (str(userid) in players) and not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
		if choice == 'Soldat':
			players[str(userid)] = Soldat(userid)
		elif choice == 'Garde du corps':
			players[str(userid)] = GardeCorps(userid)
		elif choice == 'Djihadiste':
			players[str(userid)] = Djihadiste(userid)
		elif choice == 'Commando':
			players[str(userid)] = Commando(userid)
		elif choice == 'Tête brulée':
			players[str(userid)] = TeteBrulee(userid)
		elif choice == 'Tireur d\'élite':
			players[str(userid)] = Sniper(userid)
		elif choice == 'Espion':
			players[str(userid)] = Espion(userid)
		elif choice == 'Geeky':
			players[str(userid)] = Geeky(userid)
		elif choice == 'Médecin':
			players[str(userid)] = Medecin(userid)
		else:
			players[str(userid)] = Soldat(userid)
		players[str(userid)].player_spawn()
		
def choixAutomatiqueClasse(userid):
	global players
	if (userid in players) and not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
		if players[str(userid)] == None:
			popuplib.close('classe', userid)
			players[str(userid)] = Soldat(userid)
			players[str(userid)].player_spawn()
			
#------------------------------------------------------#
#------------------- Mort d'un roi --------------------#
#------------------------------------------------------#
def forcerPerdant(equipe):
	gamethread.cancelDelayed('cyclesAssault')
	es.server.queuecmd('sv_alltalk 1')
	if geeky.alivePlayers(equipe) >= 1:
		gamethread.delayedname(30, 'tempos', execution_auto, equipe)
		geeky.msg('[CdR MoD]', 'Les troupes ennemies vont faire exécuter les derniers soldats.')
		geeky.msg('[CdR MoD]', 'Exécution automatique dans #lightgreen30 secondes#default.')
		if equipe == 3:
			coordTmp = random.choice(es.createentitylist('info_player_terrorist').keys())
			coord = es.getindexprop(coordTmp, 'CBaseEntity.m_vecOrigin').split(',')
		else:
			coordTmp = random.choice(es.createentitylist('info_player_counterterrorist').keys())
			coord = es.getindexprop(coordTmp, 'CBaseEntity.m_vecOrigin').split(',')
		for player in geeky.playerListAlive(equipe):
			geeky.removePlayerWeapons(player)
			geeky.giveWeapon(player, 'knife')
			es.server.queuecmd('es_xsetpos %s %s %s %s' % (player, coord[0], coord[1], coord[2]))
		
def execution_auto(equipe):
	if geeky.alivePlayers(equipe) >= 1:
		for player in geeky.playerListAlive(equipe):
			geeky.slay(player)
		geeky.msg('[CdR MoD]', 'Les soldats ont tous été exécutés.')
		
#------------------------------------------------------#
#---------- Interdiction de lâcher une arme -----------#
#------------------------------------------------------#
def clientCommandFilter(userid, args):
	if args[0].lower() == "drop":
		return geeky.removeWeaponsOnGround()
	return True
	
#------------------------------------------------------#
#--------------------- Assaults -----------------------#
#------------------------------------------------------#
def nouvelAssault(secondes = 0):
	if (secondes == 0):
		secondes = 30
		lancerAssault()
	for player in geeky.playerListDead(2):
		if players[str(player)].respawn > 1:
			usermsg.hudhint(player, '- INFORMATIONS -\n\nNouvel assault dans:\n~%s secondes' % secondes)
	for player in geeky.playerListDead(3):
		if players[str(player)].respawn > 1:
			usermsg.hudhint(player, '- INFORMATIONS -\n\nNouvel assault dans:\n~%s secondes' % secondes)
	gamethread.delayedname(5, 'cyclesAssault', nouvelAssault, secondes - 5)
	
def lancerAssault():
	for player in geeky.playerListDead(2):
		if players[str(player)].respawn > 1:
			players[str(player)].respawn -= 1
			es.server.queuecmd('est_spawn %s' % player)
	for player in geeky.playerListDead(3):
		if players[str(player)].respawn > 1:
			players[str(player)].respawn -= 1
			es.server.queuecmd('est_spawn %s' % player)
	return
	
#------------------------------------------------------#
#--------------------- Commandes ----------------------#
#------------------------------------------------------#
def activerSuicide():
	global suicide_actif
	suicide_actif = 1
	geeky.msg('[CdR MoD]', 'Tapez #lightgreen!suicide#default dans le chat pour vous suicider.')

def suicide():
	if suicide_actif:
		userid = es.getcmduserid()
		geeky.slay(userid)